using Bp.Sync.Dto.Results;
using CommonLibrary;
using Dapper;
using EasyNetQ;
using Microsoft.Extensions.Configuration;
using System;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Bp.Sync.BackEnd.Infrastructure.Repositories.FcBusinesses;
using Vina.Search.Infrastructure.Mappings;

namespace Bp.Sync.BackEnd.Application.Commands.FcBusinesses.Bills
{
    public class SyncFcInboundBillHandler : MediatR.IRequestHandler<SyncFcInboundBillCommand, BaseResult>
    {
        private readonly IDbConnection _dbConnection;
        private readonly IFcInboundBillRepository _FcInboundBillRepository;
        private readonly IBus _bus;

        public SyncFcInboundBillHandler(IConfiguration configuration, IFcInboundBillRepository FcInboundBillRepository, IBus bus)
        {
            var connectionString = configuration.GetConnectionString("FcBusinessConnection");
            _dbConnection = new SqlConnection(connectionString);
            _FcInboundBillRepository = FcInboundBillRepository;
            _bus = bus;
        }

        public async Task<BaseResult> Handle(SyncFcInboundBillCommand request, CancellationToken cancellationToken)
        {
            var rs = new BaseResult();

            if (request.Ids.Count() > 1000)
            {
                var length = request.Ids.Count();
                if (length > 0)
                {
                    for (int i = 0; i <= length / 1000; i++)
                    {
                        if (length > i * 1000)
                        {
                            var ids = request.Ids.Skip(i * 1000).Take(1000).ToList();
                            if (ids.Count() > 0)
                            {
                                await _bus.SendAsync($"SyncToElasticFcInboundBill", ids.ConvertListLongToString());
                            }
                        }
                    }
                }
                return new BaseResult { Result = Result.Success, Message = $"sent {length} FcInboundBills" };
            }
            if (!request.Ids.Any())
            {
                rs.Message = $"no data to update";
                rs.Result = Dto.Results.Result.Success;
                return rs;
            }

            try
            {
                var p = new Dto.DapperTypes.IdsParam(request.Ids);
                var FcInboundBills = await _dbConnection.QueryAsync<Domain.Entities.FcBusinesses.Bills.InboundBill>("Sync_InboundBill_Get_By_List_Id", p, commandType: CommandType.StoredProcedure);
                if (FcInboundBills.Any())
                {
                    var FcInboundBillRs = FcInboundBills.ToFcInboundBills();
                    var rs2 = await _FcInboundBillRepository.AddManyAsync(FcInboundBillRs);
                    if (rs2.Result == Result.Success)
                    {
                        await _dbConnection.ExecuteAsync("Synced_InboundBill_By_List_Id", p, commandType: CommandType.StoredProcedure);
                        rs.Message = $"{FcInboundBillRs.Count()} synced";
                        rs.Result = Result.Success;

                        var bids = FcInboundBillRs.Select(x => x.Id).ToList();
                        await _bus.SendAsync($"UpdateFcChildBillByBill", bids.ConvertListLongToString());
                    }
                    else
                    {
                        rs.Message = $"can not insert db";
                        rs.Result = Result.Success;
                    }
                }
                else
                {
                    rs.Message = $"no data to update";
                    rs.Result = Result.Success;
                }
            }
            catch (Exception ex)
            {
                rs.Message = ex.Message.ToString();
                rs.Result = Result.SystemError;
            }
            return rs;
        }
    }
}